/*
 *  Sandbox para el script de compactacion automatica de batallas de ogame
 *  6 Mar 2007
 *  Autor: Miguel Novas
 *  Partes del codigo extraidas del propio Greasemonkey: http://www.greasespot.net/
 *  Released under the GPL license
 *  http://www.gnu.org/copyleft/gpl.html
 */

// Capture page load events and execute zipper if neccesary

window.addEventListener(
    'DOMContentLoaded',
    function(event) {
       var doc= event.originalTarget;
       try {
          if(doc.nodeType != doc.DOCUMENT_NODE) doc= doc.ownerDocument;
          if(doc.location.pathname.indexOf('bericht.php')>=0) {
             zipper_execute(doc);
          }
       } catch (e) { }
    } , true
);

// Execute zipper script

function zipper_execute(doc)
{
  zipper_evalScript( doc.defaultView,
              zipper_getContents('chrome://ogamecompactor/content/zipperParser.js') +
              zipper_getContents('chrome://ogamecompactor/content/zipperShare.js') +
              zipper_getContents('chrome://ogamecompactor/content/zipperPanel.js')
            );
}

function zipper_evalScript(window, script)
{
  var sandbox= new Components.utils.Sandbox(window);
  sandbox.window            = window;
  sandbox.document          = sandbox.window.document;
  sandbox.GM_setValue       = zipper_setPrefValue;
  sandbox.GM_getValue       = zipper_getPrefValue;
  sandbox.GM_copyToClipboard= zipper_copyToClipboard;
  sandbox.GM_getContents    = zipper_getContents;
  sandbox.GM_log            = zipper_log;
  sandbox.__proto__         = window;
  zipper_evaluateInSandbox("(function(){\n"+script+"\n})()", window.location.href, sandbox);
}

function zipper_evaluateInSandbox(code, codebase, sandbox)
{
    // DP beta+
    if (Components.utils && Components.utils.Sandbox) {
      Components.utils.evalInSandbox(code, sandbox);
    // DP alphas
    } else if (Components.utils && Components.utils.evalInSandbox) {
      Components.utils.evalInSandbox(code, codebase, sandbox);
    // 1.0.x
    } else if (Sandbox) {
      evalInSandbox(code, sandbox, codebase);
    } else {
      throw new Error("Could not create sandbox.");
    }
}

// Extended ;) GreaseMonkey API functions

function zipper_setPrefValue(prefName, value)
{
    var Prefs= zipper_getPrefs();
    var prefType = typeof(value);
    if ((Prefs.getPrefType(prefName) != 0) && prefType != typeof(zipper_getPrefValue(prefName))) {
      Prefs.deleteBranch(prefName);
    }
    switch (prefType) {
      case "string":
        Prefs.setCharPref(prefName, value);
        break;
      case "boolean":
        Prefs.setBoolPref(prefName, value);
        break;
      case "number":
        Prefs.setIntPref(prefName, Math.floor(value));
        break;
    }
}

function zipper_getPrefValue(prefName, defaultValue)
{
  try {
    var Prefs= zipper_getPrefs();
    var prefType = Prefs.getPrefType(prefName);
    if (prefType == Prefs.PREF_INVALID) {
      return defaultValue;
    }
    switch (prefType) {
      case Prefs.PREF_STRING:
        return Prefs.getCharPref(prefName);
      case Prefs.PREF_BOOL:
        return Prefs.getBoolPref(prefName);
      case Prefs.PREF_INT:
        return Prefs.getIntPref(prefName);
    }
  } catch(err) {
     return defaultValue;
  }
}

function zipper_log()
{
 // Dummy
}

function zipper_copyToClipboard(s)
{
 const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].
                                    getService(Components.interfaces.nsIClipboardHelper);
  gClipboardHelper.copyString(s);
}

function zipper_getContents(aURL)
{
  var ioService= Components.classes["@mozilla.org/network/io-service;1"]
                 .getService(Components.interfaces.nsIIOService);
  var scriptableStream= Components.classes["@mozilla.org/scriptableinputstream;1"]
                        .getService(Components.interfaces.nsIScriptableInputStream);
  var unicodeConverter= Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                        .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
  unicodeConverter.charset =  "UTF-8";
  var channel=ioService.newChannelFromURI( ioService.newURI(aURL,'UTF-8',null) );
  var input=channel.open();
  scriptableStream.init(input);
  var str=scriptableStream.read(input.available());
  scriptableStream.close();
  input.close();
  try {
    return unicodeConverter.ConvertToUnicode(str);
  } catch( e ) {
    return str;
  }
}

function zipper_getPrefs()
{
 if(typeof(Prefs) == 'undefined') {
   Prefs= Components.classes["@mozilla.org/preferences-service;1"].
          getService(Components.interfaces.nsIPrefService).
          getBranch("extensions.ogamecompactor.");
 }
 return Prefs;
}
